using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class MainModClass
    {
        public static void Main()
        {
            ModAPI.Register(new Modification()
            {
                NameOverride = "Bounce Ball",
                DescriptionOverride = "a Bouncy Ball...",
                NameToOrderByOverride = "Ball",
                OriginalItem = ModAPI.FindSpawnable("Soap"),
                CategoryOverride = ModAPI.FindCategory("Entities"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/Ballthumpnail.png"),
                AfterSpawn = (System.Action<GameObject>)(Instance =>
                {
                    Instance.AddComponent<RandomSpriteBehaviour>();
                    Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                     ModAPI.LoadSprite("Textures/Ball1.png"),
                     ModAPI.LoadSprite("Textures/Ball2.png"),
                     ModAPI.LoadSprite("Textures/Ball3.png"),
                     //...ball 4 is missing...
                     ModAPI.LoadSprite("Textures/Ball5.png"),
                     ModAPI.LoadSprite("Textures/Ball6.png"),
                     ModAPI.LoadSprite("Textures/Ball7.png"),
                     ModAPI.LoadSprite("Textures/Ball8.png"),
                     ModAPI.LoadSprite("Textures/Ball9.png"),
                     ModAPI.LoadSprite("Textures/Ball10.png"),
                     ModAPI.LoadSprite("Textures/Ball11.png"),
                     ModAPI.LoadSprite("Textures/Ball12.png"),
                    };
                    foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
                    UnityEngine.Object.Destroy(component);
                    Instance.AddComponent<CircleCollider2D>().sharedMaterial = new PhysicsMaterial2D()
                    {
                        bounciness = 0.7f
                    };
                    Instance.GetComponent<CircleCollider2D>().radius = 0.55f;
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                    Instance.transform.localScale = new Vector2(0.65f, 0.65f);
                })
            });
        }
    }

}